﻿// Copyright (c) 2010
// by Michael Washington

using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization;
using System.IO;

namespace ViewModelTreeControl
{
    public static class ExtensionMethods
    {
        #region Extensions
        // From http://forums.silverlight.net/forums/p/19791/67551.aspx
        public static IEnumerable<Category> AllChildren(this Category _Category)
        {
            foreach (Category element in _Category.Categories)
            {
                yield return element;
                Category CategoryElement = element as Category;
                if (CategoryElement != null)
                    foreach (Category Child in CategoryElement.AllChildren())
                        yield return Child;
            }
        }
        #endregion
    }
}
